/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source$
*  $Author$
*  $Date$
*  $Revision$
*
*******************************************************************************
*
* Change History
*
* $Log$
*
*******************************************************************************
*/

#ident "$Header$"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <mplib1/mplib1_config.h>

#include <mplib1/mpbasename.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

/* ---------------------------------------------------------------------------
   Function                 : mpbasename
   Summary                  : This function returns a pointer to the base name
                            : of the filename given
   Input Parameters         : pointer to a filename
   Output Parameters        : None
   Global Variables         : None
   Return Value             : pointer to basename of filename
   --------------------------------------------------------------------------*/
char *
mpbasename ( const char *full_name )
{
    const char *cp;

    cp = full_name + strlen(full_name) - 1;
    while ( cp > full_name && *cp != '/' ) cp --;
    if ( *cp == '/' ) cp++;
    return((char *)(size_t)cp);
}



/* -- End of File -- */
